diff -uwr source/scripts/tcw_game.cpp 4.0/source/scripts/tcw_game.cpp
--- source/scripts/tcw_game.cpp	2011-09-03 08:30:06.000000000 +0800
+++ 4.0/source/scripts/tcw_game.cpp	2011-10-14 22:25:11.459960900 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
 	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011 MP-Gaming
+	Copyright 2011-2012 MP-Gaming
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
@@ -16,7 +16,9 @@
 #include "engine.h"
 #include "BuildingGameObj.h"
 #include "tcw_game.h"
-
+#include "GameObjManager.h"
+#include "SoldierGameObj.h"
+#include "VehicleGameObj.h"
 
 void tcw_Tiberium_Harvester::Created(GameObject *obj)
 {
@@ -24,6 +26,12 @@
 	driver = 0;
 	cash = 0;
 	ID = 0;
+	if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester_Player") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Nod_Harvester_Player") == 0) ) 
+	{
+		VehicleGameObj* harvester = obj->As_VehicleGameObj();
+		if (!harvester) return;
+		harvester->Set_Allow_Stealth_While_Empty(true);
+	}
 }
 void tcw_Tiberium_Harvester::Custom(GameObject *obj,int type,int param,GameObject *sender)
 {
@@ -230,21 +238,21 @@
 						{
 							Commands->Start_Timer(obj,this,20.0f,101);
 						}
-						if (capturer)
+						if (Commands->Find_Object(capturer))
 						{
 							if (Commands->Get_Player_Type(Commands->Find_Object(capturer)) == 0)
 							{
 								char capturerd[250];
 								sprintf(capturerd,"%s is capturing a Tiberium Spike.",Get_Player_Name(Commands->Find_Object(capturer)));
 								Send_Message_Team(0,255,0,0,capturerd);
-								Create_2D_WAV_Sound_Team("incmsg.wav",0);
+								Create_2D_WAV_Sound_Team("building_capture.wav",0);
 							}
 							else if (Commands->Get_Player_Type(Commands->Find_Object(capturer)) == 1)
 							{
 								char capturerd[250];
 								sprintf(capturerd,"%s is capturing a Tiberium Spike.",Get_Player_Name(Commands->Find_Object(capturer)));
 								Send_Message_Team(1,255,204,0,capturerd);
-								Create_2D_WAV_Sound_Team("incmsg.wav",1);
+								Create_2D_WAV_Sound_Team("building_capture.wav",1);
 							}
 						}
 					}
@@ -294,6 +302,7 @@
 					Create_2D_WAV_Sound_Team("nod_building_captured.wav",0);
 					Send_Message_Team(0,255,0,0,"Building captured.");
 				}
+				Commands->Give_Points(Commands->Find_Object(capturer),250.0f,0);
 				Remove_Script(Commands->Find_Object(capturer),"tcw_i_can_capture_spike");
 				capturing = false;
 				capturer = 0;
@@ -334,6 +343,7 @@
 					Create_2D_WAV_Sound_Team("gdi_building_captured.wav",1);
 					Send_Message_Team(1,255,204,0,"Building captured.");
 				}
+				Commands->Give_Points(Commands->Find_Object(capturer),250.0f,0);
 				Remove_Script(Commands->Find_Object(capturer),"tcw_i_can_capture_spike");
 				capturing = false;
 				capturer = 0;
@@ -625,6 +635,8 @@
 void tcw_Tiberium_Field_New::Entered(GameObject *obj, GameObject *enter)
 {
 	if ( (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Harvester_Player") == 0) || 
+		 (strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_GDI_Harvester_Player") == 0) || 
+		 (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Nod_Harvester_Player") == 0) || 
 		 (strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_Harvester_Player") == 0) )
 	{
 		if (zonetype == 0)//green
@@ -640,6 +652,8 @@
 void tcw_Tiberium_Field_New::Exited(GameObject *obj, GameObject *exit)
 {
 	if ( (strcmp(Commands->Get_Preset_Name(exit),"TCW_GDI_Harvester_Player") == 0) || 
+		 (strcmp(Commands->Get_Preset_Name(exit),"TCW_Nod_GDI_Harvester_Player") == 0) || 
+		 (strcmp(Commands->Get_Preset_Name(exit),"TCW_GDI_Nod_Harvester_Player") == 0) || 
 		 (strcmp(Commands->Get_Preset_Name(exit),"TCW_Nod_Harvester_Player") == 0) )
 	{
 		Commands->Send_Custom_Event(obj,exit,10500,3,0);//tell harv left zone
@@ -658,6 +672,12 @@
 	hasblue = false;
 	team = -1;
 	driverid = 0;
+	if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Nod_Harvester_Player") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester_Player") == 0) )
+	{
+		VehicleGameObj* harvester = obj->As_VehicleGameObj();
+		if (!harvester) return;
+		harvester->Set_Allow_Stealth_While_Empty(true);
+	}
 }
 void tcw_Tiberium_Harvester_New::Custom(GameObject *obj, int message, int param, GameObject *sender)
 {
@@ -727,14 +747,14 @@
 							char dumpmsg[250];
 							sprintf(dumpmsg,"%s deposited Tiberium funding Nod with %g additional credits.",Get_Player_Name(Commands->Find_Object(driverid)),tiberiumvalue);
 							Send_Message_Team(0,255,0,0,dumpmsg);
-							Create_2D_WAV_Sound_Team("creditsacquired.wav",0);
+							Create_2D_WAV_Sound_Team("creditsacquired_nod.wav",0);
 						}
 						else if (team == 1)
 						{
 							char dumpmsg[250];
 							sprintf(dumpmsg,"%s deposited Tiberium funding GDI with %g additional credits.",Get_Player_Name(Commands->Find_Object(driverid)),tiberiumvalue);
 							Send_Message_Team(1,255,204,0,dumpmsg);
-							Create_2D_WAV_Sound_Team("creditsacquired.wav",1);
+							Create_2D_WAV_Sound_Team("creditsacquired_gdi.wav",1);
 						}
 						tiberiumvalue = 0.0f;
 						hasblue = false;
@@ -755,6 +775,20 @@
 			{
 				Commands->Start_Timer(obj,this,1.0f,10500);
 				tiberiumvalue = tiberiumvalue+100.0f;
+
+				if (team == 0)
+				{
+					char amount[250];
+					sprintf(amount,"You harvested $%g worth of Tiberium Crystals.",tiberiumvalue);
+					Send_Message_Player(Commands->Find_Object(driverid),255,0,0,amount);
+				}
+				else if (team == 1)
+				{
+					char amount[250];
+					sprintf(amount,"You harvested $%g worth of Tiberium Crystals.",tiberiumvalue);
+					Send_Message_Player(Commands->Find_Object(driverid),255,204,0,amount);
+				}
+
 				if (tiberiumvalue == 1400.0f)
 				{
 					if (team == 0)
@@ -780,6 +814,20 @@
 			{
 				Commands->Start_Timer(obj,this,1.0f,10501);
 				tiberiumvalue = tiberiumvalue+200.0f;
+
+				if (team == 0)
+				{
+					char amount[250];
+					sprintf(amount,"You harvested $%g worth of Tiberium Crystals.",tiberiumvalue);
+					Send_Message_Player(Commands->Find_Object(driverid),255,0,0,amount);
+				}
+				else if (team == 1)
+				{
+					char amount[250];
+					sprintf(amount,"You harvested $%g worth of Tiberium Crystals.",tiberiumvalue);
+					Send_Message_Player(Commands->Find_Object(driverid),255,204,0,amount);
+				}
+
 				if (tiberiumvalue == 2800.0f)
 				{
 					if (team == 0)
@@ -810,12 +858,344 @@
 void tcw_Tiberium_Deposit_New::Entered(GameObject *obj, GameObject *enter)
 {
 	if ( (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Harvester_Player") == 0) || 
+		 (strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_GDI_Harvester_Player") == 0) || 
+		 (strcmp(Commands->Get_Preset_Name(enter),"TCW_GDI_Nod_Harvester_Player") == 0) ||
 		 (strcmp(Commands->Get_Preset_Name(enter),"TCW_Nod_Harvester_Player") == 0) )
 	{
 		Commands->Send_Custom_Event(obj,enter,10500,4,0);//tell harv deposit tib
 	}
 }
 
+void tcw_There_Must_Be_Engineer::Created(GameObject *obj)
+{
+	SList<SoldierGameObj> *player_list = &GameObjManager::StarGameObjList;
+	SLNode<SoldierGameObj> *objnode;
+	for (objnode = player_list->Head(); objnode; objnode = objnode->Next()) 
+	{
+		SoldierGameObj *soldier = objnode->Data();
+		if ( soldier != NULL ) 
+		{
+			if (Commands->Get_Player_Type(soldier) == 0)
+			{
+				if (!Is_Building_Dead(Find_Building(0,BuildingConstants::TYPE_SOLDIER_FACTORY)))
+				{
+					if (strcmp(Commands->Get_Preset_Name(soldier),"CnC_Nod_Minigunner_0") == 0)
+					{
+						Change_Character(soldier,"TCW_Nod_Saboteur");
+						break;
+					}
+					else if (strcmp(Commands->Get_Preset_Name(soldier),"TCW_Nod_Spawn_Low") == 0)
+					{
+						Change_Character(soldier,"TCW_Nod_Saboteur_Low");
+						break;
+					}
+				}
+				else
+				{
+					break;
+				}
+			}
+			else if (Commands->Get_Player_Type(soldier) == 1)
+			{
+				if (!Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_SOLDIER_FACTORY)))
+				{
+					if (strcmp(Commands->Get_Preset_Name(soldier),"CnC_GDI_MiniGunner_0") == 0)
+					{
+						Change_Character(soldier,"TCW_GDI_Engineer");
+						break;
+					}
+					else if (strcmp(Commands->Get_Preset_Name(soldier),"TCW_GDI_Spawn_Low") == 0)
+					{
+						Change_Character(soldier,"TCW_GDI_Engineer_Low");
+						break;
+					}
+				}
+				else
+				{
+					break;
+				}
+			}
+		}
+	}
+}
+
+void tcw_Enable_Refill::Created(GameObject *obj)
+{
+	//
+}
+
+void tcw_Buy_Beacon_Ion::Created(GameObject *obj)
+{
+	type = Get_Int_Parameter("Type");//1=10s 2=60s beacon
+	allowpoke = true; Commands->Enable_HUD_Pokable_Indicator(obj, true);
+	ionholder = 0;
+	ready = false;
+	charging = true; Commands->Start_Timer(obj,this,30.0f,100100);//commence charging of the ion
+}
+void tcw_Buy_Beacon_Ion::Register_Auto_Save_Variables()
+{
+	Auto_Save_Variable(&type,sizeof(type),1);
+	Auto_Save_Variable(&allowpoke,sizeof(allowpoke),2);
+	Auto_Save_Variable(&ionholder,sizeof(ionholder),3);
+	Auto_Save_Variable(&ready,sizeof(ready),4);
+	Auto_Save_Variable(&charging,sizeof(charging),5);
+}
+void tcw_Buy_Beacon_Ion::Timer_Expired(GameObject *obj, int number)
+{
+	if (number == 100100)
+	{
+		if (!Is_Building_Dead(Find_Object_By_Preset(1,"GDI_Ion_Control_Center")))
+		{
+			if (charging)
+			{
+				ready = true;
+				charging = false;
+				Create_2D_WAV_Sound_Team("gdi_ion_cannon_ready.wav",1);
+				Send_Message_Team(1,255,204,0,"Ion Cannon Ready.");
+			}
+		}
+	}
+	else if (number == 100101)
+	{
+		if (!Is_Building_Dead(Find_Object_By_Preset(1,"GDI_Ion_Control_Center")))
+		{
+			allowpoke = true; Commands->Enable_HUD_Pokable_Indicator(obj, true);
+		}
+	}
+}
+void tcw_Buy_Beacon_Ion::Poked(GameObject *obj, GameObject *poker)
+{
+	if (allowpoke)
+	{
+		if (Commands->Get_Player_Type(poker) == 1)
+		{
+			if (ready)
+			{
+				if (!ionholder)
+				{
+					ionholder = Commands->Get_ID(poker);
+					char ionguymsg[250];
+					sprintf(ionguymsg,"%s please select the Ion Cannon Target.",Get_Player_Name(Commands->Find_Object(ionholder)));
+					Send_Message_Team(1,255,204,0,ionguymsg);
+					Commands->Create_2D_WAV_Sound("gdi_ion_select_target.wav");
+					if (type == 1)//if the mapper decided to grant 10 sec beacons
+					{
+						Commands->Give_PowerUp(Commands->Find_Object(ionholder),"TCW_POW_Beacon_Nuke_10Sec",false);
+					}
+					else if (type == 2)//if the mapper decided to grant 60 sec beacons
+					{
+						Commands->Give_PowerUp(Commands->Find_Object(ionholder),"TCW_POW_Beacon_Nuke_60Sec",false);
+					}
+					Attach_Script_Once(Commands->Find_Object(ionholder),"tcw_I_Have_Ion_Cannon_Beacon","");
+				}
+			}
+		}
+		allowpoke = false; Commands->Enable_HUD_Pokable_Indicator(obj, false); Commands->Start_Timer(obj,this,10.0f,100101);//allow true set
+	}
+}
+void tcw_Buy_Beacon_Ion::Custom(GameObject *obj, int message, int param, GameObject *sender)
+{
+	if (message == 100100)//the ion building was destroyed
+	{
+		if (param == 1)
+		{
+			ready = false;		charging = false;		allowpoke = false;
+			if (ionholder)
+			{
+				Remove_Weapon(Commands->Find_Object(ionholder),"TCW_Weapon_IonCannon_10Sec");
+				Remove_Weapon(Commands->Find_Object(ionholder),"TCW_Weapon_IonCannon_60Sec");
+			}
+		}
+	}
+	else if (message == 100101)//the guy died or left game, whatever
+	{
+		if (param == 1)
+		{
+			if (!Is_Building_Dead(Find_Object_By_Preset(1,"GDI_Ion_Control_Center")))
+			{
+				if (ready)
+				{
+					ionholder = 0;
+					allowpoke = true; Commands->Enable_HUD_Pokable_Indicator(obj, true);
+				}
+			}
+		}
+	}
+	else if (message == 100102)//successful ion strike done
+	{
+		if (param == 1)
+		{
+			if (!Is_Building_Dead(Find_Object_By_Preset(1,"GDI_Ion_Control_Center")))
+			{
+				ready = false;
+				ionholder = 0;
+				charging = true; Commands->Start_Timer(obj,this,30.0f,100100);
+				allowpoke = true; Commands->Enable_HUD_Pokable_Indicator(obj, true);
+			}
+		}
+	}
+}
+
+void tcw_Spikemap_Get_CaptureGuy::Created(GameObject *obj)
+{
+	// This script is for buying a Engineer or Saboteur for free on maps that have only spikes
+	// It should be sticked on some pokable object
+	allowpoke = true; Commands->Enable_HUD_Pokable_Indicator(obj, true);
+	type = Get_Int_Parameter("Type");
+}
+void tcw_Spikemap_Get_CaptureGuy::Poked(GameObject *obj, GameObject *poker)
+{
+	if (allowpoke)
+	{
+		if (type == 0)
+		{
+			if (!Is_Building_Dead(Find_Building(0,BuildingConstants::TYPE_SOLDIER_FACTORY)))
+			{
+				if (Commands->Get_Player_Type(poker) == type)
+				{
+					if (Get_Object_Count(0,"TCW_Nod_Saboteur") < 1)
+					{
+						Change_Character(poker,"TCW_Nod_Saboteur");
+					}
+				}
+			}
+		}
+		else if (type == 1)
+		{
+			if (!Is_Building_Dead(Find_Building(1,BuildingConstants::TYPE_SOLDIER_FACTORY)))
+			{
+				if (Commands->Get_Player_Type(poker) == type)
+				{
+					if (Get_Object_Count(1,"TCW_GDI_Engineer") < 1)
+					{
+						Change_Character(poker,"TCW_GDI_Engineer");
+					}
+				}
+			}
+		}
+		allowpoke = false; Commands->Enable_HUD_Pokable_Indicator(obj, false); Commands->Start_Timer(obj,this,5.0f,100100);
+	}
+}
+void tcw_Spikemap_Get_CaptureGuy::Timer_Expired(GameObject *obj, int number)
+{
+	if (number == 100100)
+	{
+		allowpoke = true; Commands->Enable_HUD_Pokable_Indicator(obj, true);
+	}
+}
+void tcw_Spikemap_Get_CaptureGuy::Register_Auto_Save_Variables()
+{
+	Auto_Save_Variable(&allowpoke,sizeof(allowpoke),1);
+	Auto_Save_Variable(&type,sizeof(type),1);
+}
+
+void tcw_Death_Blowup_Building::Killed(GameObject *obj, GameObject *shooter)
+{
+	int type = Get_Int_Parameter("Type");
+	const char *building = Get_Parameter("Building_Name");
+	Commands->Apply_Damage(Find_Building_By_Name(type,building),99999.0f,"C4",shooter);
+}
+
+void tcw_zone_teleport_random_id::Created(GameObject *obj)
+{
+	targetid1 = Get_Int_Parameter("ID1");
+	targetid2 = Get_Int_Parameter("ID2");
+	targetid3 = Get_Int_Parameter("ID3");
+	tele = true;
+}
+void tcw_zone_teleport_random_id::Entered(GameObject *obj, GameObject *enter)
+{
+	if (tele)
+	{
+		if (!Get_Vehicle(enter))
+		{
+			tele = false; Commands->Start_Timer(obj,this,3.0f,100);
+			int random = Commands->Get_Random_Int(1,3);
+			if (random == 1)
+			{
+				GameObject *gotoObject;
+				gotoObject = Commands->Find_Object(targetid1);
+				Vector3 gotoLoc = Commands->Get_Position(gotoObject);
+				Commands->Set_Position(enter,gotoLoc);
+			}
+			else if (random == 2)
+			{
+				GameObject *gotoObject;
+				gotoObject = Commands->Find_Object(targetid2);
+				Vector3 gotoLoc = Commands->Get_Position(gotoObject);
+				Commands->Set_Position(enter,gotoLoc);
+			}
+			else if (random == 3)
+			{
+				GameObject *gotoObject;
+				gotoObject = Commands->Find_Object(targetid3);
+				Vector3 gotoLoc = Commands->Get_Position(gotoObject);
+				Commands->Set_Position(enter,gotoLoc);
+			}
+		}
+	}
+}
+void tcw_zone_teleport_random_id::Timer_Expired(GameObject *obj, int number)
+{
+	if (number == 100)
+	{
+		tele = true;
+	}
+}
+void tcw_zone_teleport_random_id::Register_Auto_Save_Variables()
+{
+	Auto_Save_Variable(&targetid1,sizeof(targetid1),1);
+	Auto_Save_Variable(&targetid2,sizeof(targetid1),2);
+	Auto_Save_Variable(&targetid3,sizeof(targetid1),3);
+	Auto_Save_Variable(&tele,sizeof(tele),4);
+}
+
+void tcw_dm_map_tech3::Created(GameObject *obj)//no limits
+{
+	//no limitations on map
+}
+void tcw_dm_map_tech2::Created(GameObject *obj)//no commando's
+{
+	Hide_Preset_By_Name(1,"TCW_GDI_Commando",true);
+	Hide_Preset_By_Name(1,"TCW_GDI_Commando_Low",true);
+	Hide_Preset_By_Name(0,"TCW_Nod_Commando",true);
+	Hide_Preset_By_Name(0,"TCW_Nod_Commando_Low",true);
+}
+void tcw_dm_map_tech1::Created(GameObject *obj)//no snipers, shadows and commando's
+{
+	Hide_Preset_By_Name(1,"TCW_GDI_Commando",true);
+	Hide_Preset_By_Name(1,"TCW_GDI_Commando_Low",true);
+	Hide_Preset_By_Name(1,"TCW_GDI_Sniper",true);
+	Hide_Preset_By_Name(1,"TCW_GDI_Sniper_Low",true);
+	Hide_Preset_By_Name(0,"TCW_Nod_Commando",true);
+	Hide_Preset_By_Name(0,"TCW_Nod_Commando_Low",true);
+	Hide_Preset_By_Name(0,"TCW_Nod_Shadow",true);
+	Hide_Preset_By_Name(0,"TCW_Nod_Shadow_Low",true);
+}
+
+void tcw_destroyed_send_custom::Destroyed(GameObject *obj)
+{
+	int msg = Get_Int_Parameter("Message");		int id = Get_Int_Parameter("SendID");	int prm = Get_Int_Parameter("Param");
+	Commands->Send_Custom_Event(obj,Commands->Find_Object(id),msg,prm,0);
+}
+
+void tcw_test::Created(GameObject *obj)
+{
+	Console_Input("msg script created");
+}
+
+
+ScriptRegistrant<tcw_test> tcw_test_Registrant("tcw_test","");
+ScriptRegistrant<tcw_destroyed_send_custom> tcw_destroyed_send_custom_Registrant("tcw_destroyed_send_custom","Message=1000:int,SendID=1000:int,Param=1:int");
+ScriptRegistrant<tcw_dm_map_tech1> tcw_dm_map_tech1_Registrant("tcw_dm_map_tech1","");
+ScriptRegistrant<tcw_dm_map_tech2> tcw_dm_map_tech2_Registrant("tcw_dm_map_tech2","");
+ScriptRegistrant<tcw_dm_map_tech3> tcw_dm_map_tech3_Registrant("tcw_dm_map_tech3","");
+ScriptRegistrant<tcw_zone_teleport_random_id> tcw_zone_teleport_random_id_Registrant("tcw_zone_teleport_random_id","ID1=1:int,ID2=2:int,ID3=3:int");
+ScriptRegistrant<tcw_Death_Blowup_Building> tcw_Death_Blowup_Building_Registrant("tcw_Death_Blowup_Building","Type=0:int,Building_Name=TCW:string");
+ScriptRegistrant<tcw_Spikemap_Get_CaptureGuy> tcw_Spikemap_Get_CaptureGuy_Registrant("tcw_Spikemap_Get_CaptureGuy","Type=0:int");
+ScriptRegistrant<tcw_Buy_Beacon_Ion> tcw_Buy_Beacon_Ion_Registrant("tcw_Buy_Beacon_Ion","Type=2:int");
+ScriptRegistrant<tcw_Enable_Refill> tcw_Enable_Refill_Registrant("tcw_Enable_Refill","");
+ScriptRegistrant<tcw_There_Must_Be_Engineer> tcw_There_Must_Be_Engineer_Registrant("tcw_There_Must_Be_Engineer","");
 ScriptRegistrant<tcw_Tiberium_Deposit_New> tcw_Tiberium_Deposit_New_Registrant("tcw_Tiberium_Deposit_New","");
 ScriptRegistrant<tcw_Tiberium_Harvester_New> tcw_Tiberium_Harvester_New_Registrant("tcw_Tiberium_Harvester_New","");
 ScriptRegistrant<tcw_Tiberium_Field_New> tcw_Tiberium_Field_New_Registrant("tcw_Tiberium_Field_New","Zonetype=0:int");
diff -uwr source/scripts/tcw_game.h 4.0/source/scripts/tcw_game.h
--- source/scripts/tcw_game.h	2011-08-29 08:56:56.000000000 +0800
+++ 4.0/source/scripts/tcw_game.h	2011-10-15 12:39:38.274414000 +0800
@@ -1,6 +1,6 @@
 /*	Renegade Scripts.dll
 	Scripts by zunnie - http://dev.mp-gaming.com
-	Copyright 2011 MP-Gaming
+	Copyright 2011-2012 MP-Gaming
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
@@ -11,7 +11,7 @@
 	with any closed source module that does not contain code covered by this licence.
 	Only the source code to the module(s) containing the licenced code has to be released.
 */
-
+#pragma once
 
 class tcw_Tiberium_Harvester : public ScriptImpClass {
 	int driver;
@@ -122,3 +122,72 @@
 class tcw_Tiberium_Deposit_New : public ScriptImpClass {
 	void Entered(GameObject *obj, GameObject *enter);
 };
\ No newline at end of file
+
+class tcw_There_Must_Be_Engineer : public ScriptImpClass {
+	void Created(GameObject *obj);
+}; 
+
+class tcw_Enable_Refill : public ScriptImpClass {
+	void Created(GameObject *obj);
+}; 
+
+class tcw_Buy_Beacon_Ion : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj, int number);
+	void Poked(GameObject *obj, GameObject *poker);
+	void Custom(GameObject *obj, int message, int param, GameObject *sender);
+	public: void Register_Auto_Save_Variables();
+	bool charging;
+	bool ready;
+	bool allowpoke;
+	int ionholder;
+	int type;
+}; 
+
+class tcw_Spikemap_Get_CaptureGuy : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Poked(GameObject *obj, GameObject *poker);
+	void Timer_Expired(GameObject *obj, int number);
+	public: void Register_Auto_Save_Variables();
+	bool allowpoke;
+	int type;
+	int target;
+	int targetlow;
+}; 
+
+class tcw_Death_Blowup_Building : public ScriptImpClass {
+	void Killed(GameObject *obj, GameObject *shooter);
+}; 
+
+class tcw_zone_teleport_random_id : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Entered(GameObject *obj, GameObject *enter);
+	void Timer_Expired(GameObject *obj, int number);
+	public: void Register_Auto_Save_Variables();
+	int targetid1;
+	int targetid2;
+	int targetid3;
+	bool tele;
+}; 
+
+class tcw_dm_map_tech3 : public ScriptImpClass {
+	void Created(GameObject *obj);
+}; 
+class tcw_dm_map_tech2 : public ScriptImpClass {
+	void Created(GameObject *obj);
+}; 
+class tcw_dm_map_tech1 : public ScriptImpClass {
+	void Created(GameObject *obj);
+}; 
+
+class tcw_destroyed_send_custom : public ScriptImpClass {
+	void Destroyed(GameObject *obj);
+}; 
+
+class tcw_test : public ScriptImpClass {
+	void Created(GameObject *obj);
+}; 
+
+
+
+
